local addonName, TF = ...

local TradeFill = LibStub("AceAddon-3.0"):GetAddon(addonName)
local Loc = LibStub("AceLocale-3.0"):GetLocale(addonName)

local Minimap = LibStub("LibDBIcon-1.0", true)

function Minimap:InitializeMinimapButton(self)
    icon = LibStub("LibDataBroker-1.1"):NewDataObject("minimap", Minimap:defaultsMinimap())
    Minimap:Register("minimap", icon, self.db.profile.minimap)


    if TradeFill.db.profile.setting.auto then
        Minimap:setButtonOn()
    else
        Minimap:setButtonOff()
    end
end

function Minimap:defaultsMinimap()
    return
    {
        type = "data source",
        text = "minimap",
        icon = "",
        OnTooltipShow = function(tooltip)
            tooltip:SetText("|c8788EEff" .. addonName .. "|r")
            tooltip:AddLine(Minimap:setTooltipLeftClick(Loc["MINIMAP_LEFT_CLICK_ENABLE"]))
            tooltip:AddLine(Minimap:setTooltipRightClick(Loc["MINIMAP_RIGHT_CLICK_OPEN"]))
            tooltip:Show()
        end,
        OnClick = function(self, click )
            if click == "LeftButton" then

                if TradeFill.db.profile.setting.auto then
                    TradeFill:setOff()
                    Minimap:setButtonOff()
                else
                    TradeFill:setOn()
                    Minimap:setButtonOn()
                end
            end

            if click == "RightButton" then
                if SettingsPanel:IsShown() then
                    HideUIPanel(SettingsPanel)
                    HideUIPanel(GameMenuFrame)
                else
                    TradeFill:SlashCommand()
                end
            end
        end
    }
end

function Minimap:setTooltipLeftClick()
    local text = Loc["MINIMAP_LEFT_CLICK_ENABLE"]

    if TradeFill.db.profile.setting.auto then
        text = Loc["MINIMAP_LEFT_CLICK_DISABLE"]
    end
    return text
end

function Minimap:setTooltipRightClick()
    local text = Loc["MINIMAP_RIGHT_CLICK_OPEN"]

    if SettingsPanel:IsShown() then
        text = Loc["MINIMAP_RIGHT_CLICK_CLOSE"]
    end
    return text
end

function Minimap:setButtonOn()
    icon.icon = "Interface\\AddOns\\"..addonName.."\\images\\Spell_Nature_Polymorph_Cow.tga"
end

function Minimap:setButtonOff()
    icon.icon = "Interface\\AddOns\\"..addonName.."\\images\\Spell_Nature_Polymorph_Cow_Red.tga"
end